<?php

session_start();

// Sprawdzenie tokena CSRF
if (!isset($_POST['csrf_token']) || $_POST['csrf_token'] !== $_SESSION['csrf_token']) {
    die("Nieprawidłowy token CSRF.");
}

// Otworzenie pliku dane.txt w trybie do odczytu (r)
$file = fopen("dane.txt", "r");
// Przygotowanie zmiennej na zawartość pliku bez pierwszego wiersza
$newFileContent = "Numer przesyłki;Numer zamówienia\n";

// Pomijanie pierwszego wiersza z nagłówkami
fgets($file);

// Inicjalizacja cURL
$curl = curl_init("https://api.baselinker.com/connector.php");
curl_setopt($curl, CURLOPT_POST, 1);
curl_setopt($curl, CURLOPT_HTTPHEADER, ["X-BLToken: xxx"]); // Tutaj dodaj swój token
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

$addedNumbersCount = 0;

// Przetwarzanie kolejnych wierszy
while (($row = fgetcsv($file, 0, ";")) !== false) {
	// Zapisanie danych przesyłki i zamówienia do odpowiednich zmiennych
    $package_number = htmlspecialchars($row[0], ENT_QUOTES, 'UTF-8');
    $order_id = htmlspecialchars($row[1], ENT_QUOTES, 'UTF-8');

    // Sprawdzenie, czy zamówienie posiada już numer przesyłki
    $checkParams = json_encode(["order_id" => intval($order_id)]);
    $apiCheckParams = [
        "method" => "getOrderPackages",
        "parameters" => $checkParams
    ];
    curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($apiCheckParams));
    $checkResponse = curl_exec($curl);
    $checkData = json_decode($checkResponse, true);
	
	// Przygotowanie parametrów dla API
    if (empty($checkData['packages'])) {
        $methodParams = json_encode([
            "order_id" => intval($order_id),
            "courier_code" => "InPost Paczkomaty",
            "package_number" => $package_number
        ]);
        $apiParams = [
            "method" => "createPackageManual",
            "parameters" => $methodParams
        ];
		// Wykonanie zapytania do API
        curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($apiParams));
        $response = curl_exec($curl);
		$addedNumbersCount++;
    }
}

// Zamknięcie połączenia cURL
curl_close($curl);
// Ponowne otwarcie pliku dane.txt, ale tym razem w trybie do zapisu (w), co usunie wszystkie dane i zostawi tylko nagłówek
fclose($file); // Najpierw zamykamy plik, który był otwarty do odczytu
$file = fopen("dane.txt", "w"); // Otwieramy ten sam plik, ale do zapisu
fwrite($file, $newFileContent); // Zapisujemy tylko nagłówek do pliku, usuwając pozostałe dane
fclose($file); // Zamknięcie pliku

echo "Dodano numery nadań dla $addedNumbersCount zamówień.";

?>