<?php
session_start();

if (!isset($_POST['csrf_token']) || $_POST['csrf_token'] !== $_SESSION['csrf_token']) {
    die("Nieprawidłowy token CSRF.");
}

if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_FILES['plikDanych'])) {
    if ($_FILES['plikDanych']['error'] === UPLOAD_ERR_OK) {
        if ($_FILES['plikDanych']['size'] > 50000) {
            die("Plik jest zbyt duży. Maksymalny dopuszczalny rozmiar to 50 KB.");
        }

        $finfo = new finfo(FILEINFO_MIME_TYPE);
        $mime = $finfo->file($_FILES['plikDanych']['tmp_name']);
        if ($mime != 'text/plain') {
            die("Nieprawidłowy typ pliku. Oczekiwano pliku tekstowego.");
        }

        $content = file_get_contents($_FILES['plikDanych']['tmp_name']);
        $lines = explode("\n", $content);

        $orders = $shipments = $results = [];
        $results[] = "Numer przesyłki;Numer zamówienia";

        foreach ($lines as $line) {
            if (strpos($line, ';') === false) continue;
            list($firstElement) = explode(";", $line);

            if (is_numeric($firstElement)) {
                if (strpos($line, '@') !== false) {
                    list($orderNumber, , , $phone, , ) = explode(";", $line);
                    $phone = htmlspecialchars(str_replace('+48', '', $phone), ENT_QUOTES, 'UTF-8');
                    $orders[$phone] = htmlspecialchars($orderNumber, ENT_QUOTES, 'UTF-8');
                } else {
                    list($shipmentNumber, $phone) = explode(";", $line);
                    $phone = htmlspecialchars(str_replace('+48', '', $phone), ENT_QUOTES, 'UTF-8');
                    $shipments[$phone] = htmlspecialchars($shipmentNumber, ENT_QUOTES, 'UTF-8');
                }
            }
        }

        foreach ($shipments as $phone => $shipmentNumber) {
            if (isset($orders[$phone])) {
                $results[] = "$shipmentNumber;{$orders[$phone]}";
            }
        }

        file_put_contents('dane.txt', implode("\n", $results));

        echo "<pre>" . htmlspecialchars(implode("\n", $results), ENT_QUOTES, 'UTF-8') . "</pre>";
    } else {
        echo "Wystąpił błąd podczas przesyłania pliku.";
    }

    // Formularz do wywołania numery_nadan_bl.php
    echo '<form action="numery_nadan_bl.php" method="post">
            <input type="hidden" name="csrf_token" value="'.$_SESSION['csrf_token'].'">
            <input type="submit" value="Dodaj numery nadań">
          </form>';
} else {
    echo "Nieprawidłowe żądanie.";
}
?>
